#ifndef DEVICESETTINGSDIALOG_H
#define DEVICESETTINGSDIALOG_H

#include <QDialog>

#include "ModularDeviceConfig.h"

class QListWidgetItem;

namespace Ui {
class DeviceSettingsDialog;
}

class DeviceSettingsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit DeviceSettingsDialog(QWidget *parent = nullptr);
    ~DeviceSettingsDialog();
    void deviceListUpdated(const QMap<DeviceIndex, ModularDeviceConfig> &s);
    void setStopConditions(int limit);

private slots:
    void on_listWidgetDevices_currentItemChanged(QListWidgetItem *current, QListWidgetItem *);

private:
    QString getDevName(const DeviceIndex &index) const;

    Ui::DeviceSettingsDialog *ui;
    QMap<DeviceIndex, ModularDeviceConfig> devices;
};

#endif // DEVICESETTINGSDIALOG_H
