#include "CruDevice.h"

#include "base/RcRunId.h"
#include "regio/regop.h"

CruDevice::CruDevice(const DeviceIndex &index, QObject *parent)
    : ModularMregDevice(index, status, parent)
    , status(index)
{
    setObjectName(getIdent());
}

void CruDevice::preRunReset(const QVariant &startEvNum, const RcRunId &rcRunId)
{
    bool ok = ModularMregDevice::preRunActions(startEvNum);
    emit preRunReseted(getDeviceIndex(), ok ? rcRunId : RcRunId());
}

bool CruDevice::readStatus()
{
    if (!ModularMregDevice::readStatus())
        return {};

    emit statusUpdated(status);
    return true;
}

bool CruDevice::writeConfig()
{
    bool ok = ModularMregDevice::writeConfig();
    ok &= writeSoftRun(config.isRun());
    return ok;
}
