/*
**    Copyright 2020 Ivan Filippov, Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICEDISCOVERMAINWINDOW_H
#define DEVICEDISCOVERMAINWINDOW_H

#include "base/app/BaseMainWindow.h"

#include <memory>

class DeviceDispatcher;
class DeviceIndex;
class DiscoverDialog;
class LldpInfoCache;
class QLabel;

namespace Ui {
class DeviceDiscoverMainWindow;
}

class DeviceDiscoverMainWindow : public BaseMainWindow
{
    Q_OBJECT

public:
    explicit DeviceDiscoverMainWindow(QWidget *parent = nullptr);
    virtual ~DeviceDiscoverMainWindow();
    virtual void closeEvent(QCloseEvent *event) override;

public slots:
    void lldpCacheUpdated(const LldpInfoCache &new_cache);

private:
    std::unique_ptr<Ui::DeviceDiscoverMainWindow> ui;
    DiscoverDialog * const discoverDialog;
    DeviceDispatcher * const deviceDispatcher;
    QLabel * const label;
};

#endif // DEVICEDISCOVERMAINWINDOW_H
