#include "MongoViewerConfigDispatcher.h"

#include "MongoViewerConfig.h"
#include <QDebug>

MongoViewerConfigDispatcher::MongoViewerConfigDispatcher(QObject *parent)
    : QObject(parent)
    , cache(new MongoViewerConfig())
{
    qRegisterMetaType<MongoViewerConfig>();
}

MongoViewerConfigDispatcher::~MongoViewerConfigDispatcher()
{
    delete cache;
}

void MongoViewerConfigDispatcher::setConfig(const MongoViewerConfig &config)
{
    if (config == *cache)
        return;
    *cache = config;
    qDebug() << __PRETTY_FUNCTION__ << "config changed";
    emit configChanged(config);
}
