#ifndef BASEEVBCLIENTFSM_H
#define BASEEVBCLIENTFSM_H

#include "fsm/BaseFsm.h"

class BaseEvbClientFsm : public BaseFsm
{
    Q_OBJECT
public:
    explicit BaseEvbClientFsm(QObject *parent = nullptr);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;
    virtual qint64 requestTimeoutMs() const override;

    virtual void doStateAction(const FsmState &st) = 0;
    virtual bool checkAllStates(const FsmState &st) const = 0;
    virtual bool hasAnyError() const = 0;

    FsmState performedStateAction = FsmState::Init;
};

#endif // BASEEVBCLIENTFSM_H
