#ifndef CLIENTMANAGERFSM_H
#define CLIENTMANAGERFSM_H

#include "BaseEvbClientFsm.h"
#include "base/ClientIndex.h"

class ClientIndexEnabledMap;

struct ClientManagerFsmInput : public BaseFsmInput
{
    ClientIndexSet clientsSet;
    QMap<ClientIndex, FsmState> clientsStates;
};

class ClientManagerFsm : public BaseEvbClientFsm
{
    Q_OBJECT
public:
    ClientManagerFsm(QObject *parent = nullptr);
    bool canSwitchTo(FsmState state) const;

signals:
    void clientListChanged(const ClientIndexEnabledMap &);

public slots:
    void setClientList(const ClientIndexEnabledMap &newList);
    void setClientState(ClientIndex index, FsmState state);

protected:
    inline ClientManagerFsmInput *getInput() {
        return static_cast<ClientManagerFsmInput*>(BaseFsm::getInput());
    }
    inline const ClientManagerFsmInput *getInput() const {
        return static_cast<const ClientManagerFsmInput*>(BaseFsm::getInput());
    }
    virtual void printInputString(QDebug dbg) const override;

    virtual void doStateAction(const FsmState &) override {}
    bool checkAllStates(const FsmState &state) const final;
    bool hasAnyError() const final;
};

QDebug operator<<(QDebug dbg, const ClientManagerFsmInput &in);

#endif // CLIENTMANAGERFSM_H
