/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MSCDACCONFIGBUILDER_H
#define MSCDACCONFIGBUILDER_H

#include "device-utils/Ad5328ConfigBuilder.h"

class MscDacConfigBuilder : public Ad5328ConfigBuilder
{
public:
    static MscDacConfigBuilder & instance()
    {
        static MscDacConfigBuilder obj;
        return obj;
    }
    Ad5328Config build(const QMap<int, int> &values) const override;

protected:
    ChannelIndex mapChannel(int channel) const override;
};

#endif // MSCDACCONFIGBUILDER_H
