/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "MscDacConverter.h"

double MscDacConverter::getDacDefaultZero() const
{
    return 2020;
}

double MscDacConverter::getVRef() const
{
    const double DAC_V_REF_MSC_THR = 2.5; // in V (+- 1.25)
    return DAC_V_REF_MSC_THR * 1e3;
}

bool MscDacConverter::getGain() const
{
    return false;
}

quint16 MscDacConverter::getDacMaxVal() const
{
    return (1<<12) - 1;
}
