/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef STATUSPUBLISHER_H
#define STATUSPUBLISHER_H

#include <QObject>

#include "TrigSpillStatistics.h"

class DeviceIndex;
struct FirmwareBuildParams;

class StatusPublisher : public QObject
{
    Q_OBJECT
public:
    explicit StatusPublisher(QObject *parent = nullptr);

public slots:
//    void onRcFsmStateChange(const FsmState &state);
//    void onClientManagerFsmStateChange(const FsmState &state);
//    void onTrigManagerFsmStateChange(const FsmState &state);
//    void onVmeFsmStateChange(const FsmState &state);
    // per device info
//    void onTrigStatusStrUpdated(const DeviceIndex &index, const QString &st);
    void onTrigStatusUpdated(const TrigStatus &status);
//    void onTrigFirmwareBuildParamsChanged(const FirmwareBuildParams &);
    void onTrigSpillStatisticsUpdated(const DeviceIndex &index, const TrigSpillStatistics &data);

signals:

protected:
    void pub(const QString &key, const QJsonDocument &json);

private:
    QStringList getDevStatePath(const DeviceIndex &index, QStringList suffix) const;

    QString appName;
};

#endif // STATUSPUBLISHER_H
