/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef VMETRIGCONFIG_H
#define VMETRIGCONFIG_H

#include <QMetaType>

struct VmeTrigConfig
{
    friend bool operator==(const VmeTrigConfig &, const VmeTrigConfig &) = default;

    bool enabled = true;
    bool checkEvNum = true;
    bool checkWr = true;
};
Q_DECLARE_METATYPE(VmeTrigConfig)

QDebug operator<<(QDebug dbg, const VmeTrigConfig &r);
QDataStream &operator<<(QDataStream &out, const VmeTrigConfig &r);
QDataStream &operator>>(QDataStream &in, VmeTrigConfig &r);

#endif // VMETRIGCONFIG_H
