//
//    Copyright 2014-2015 Ivan Filippov
//    Copyright 2014-2015 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef VMETRIGSWIDGET_H
#define VMETRIGSWIDGET_H

#include <QWidget>

#include "fsm/FsmState.h"
#include "base/DeviceIndexEnabled.h"

class DeviceDispatcher;
class DiscoverDialog;
class VmeTrigsController;
class VmeTrigsModel;
struct RcConfig;

namespace Ui {
class VmeTrigsWidget;
}

class VmeTrigsWidget : public QWidget
{
    Q_OBJECT

public:
    explicit VmeTrigsWidget(QWidget *parent = nullptr);
    ~VmeTrigsWidget();
    void setDeviceDispatcher(DeviceDispatcher *p);
    void setController(VmeTrigsController *p);

private slots:
    void on_pushButtonAddVmeTrig_clicked();
    void setRunState(const FsmState &state);

private:
    bool isCfgChangeAllowed() const;
    void updateEnableState();

    Ui::VmeTrigsWidget *ui;
    DeviceDispatcher *deviceDispatcher = nullptr;
    VmeTrigsController *controller = nullptr;
    VmeTrigsModel * const model;
    DiscoverDialog * const discoverDialog;
    FsmState fsmState = FsmState::Unknown;
};

#endif // VMETRIGSWIDGET_H
