#ifndef TRCSPINBOXDELEGATE_H
#define TRCSPINBOXDELEGATE_H

#include <QItemDelegate>

class QSpinBox;

class TrcSpinBoxDelegate : public QItemDelegate
{
Q_OBJECT
public:
    TrcSpinBoxDelegate(QObject *parent = nullptr);
    QWidget *createEditor(QWidget *parent,
                          const QStyleOptionViewItem &option,
                          const QModelIndex &index) const override;
    void setEditorData(QWidget *editor,
                       const QModelIndex &index) const override;
    void setModelData(QWidget *editor,
                      QAbstractItemModel *model,
                      const QModelIndex &index) const override;
    void updateEditorGeometry(QWidget *editor,
                              const QStyleOptionViewItem &option,
                              const QModelIndex &index) const override;

private slots:
    void dataChanged();
    void flushCommitData();

private:
    QTimer * const commitDataTimer;
    QObject * commitDataWidget = nullptr;
};

#endif // TRCSPINBOXDELEGATE_H
