#ifndef BUSYSOURCEGROUPBOX_H
#define BUSYSOURCEGROUPBOX_H

#include <QGroupBox>

#include "base/ConfigKey.h"
#include "lib-common/RunControlAppConfig.h"

namespace Ui {
class BusySourceGroupBox;
}

class BusySourceGroupBox : public QGroupBox
{
    Q_OBJECT

public:
    explicit BusySourceGroupBox(QWidget *parent = nullptr);
    ~BusySourceGroupBox();

signals:
    void configChanged(const RunControlAppConfig &config);

public slots:
    void setConfig(ConfigKey config_key, const RunControlAppConfig &config_);

private slots:
    void on_checkBoxPulse_toggled(bool vxsPulse);
    void on_checkBoxFeLink_toggled(bool vxsFeLink);

private:
    void updateGui() const;

    Ui::BusySourceGroupBox *ui;

    RunControlAppConfig config;
};

#endif // BUSYSOURCEGROUPBOX_H
