#ifndef SNMPDIALOG_H
#define SNMPDIALOG_H

#include <QDialog>

namespace Ui {
class SnmpDialog;
}

class SnmpCtrl;

struct SnmpConfig
{
    SnmpConfig() : serial(0) {}

    QString addr;
    quint32 serial;
};

class SnmpDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SnmpDialog(QWidget *parent = nullptr);
    ~SnmpDialog();

private slots:
    void on_pushButtonConnect_clicked();
    void status_poll();

private:
    void load_cfg();
    void save_cfg();
    bool connect_to_snmp();
    void disconnect_from_snmp();
    void update_button_label();

    Ui::SnmpDialog *ui;

    bool connected;
    SnmpConfig config;
    SnmpCtrl * const snmp;
};

#endif // SNMPDIALOG_H
