#ifndef TTVXSDEVICEGLOBAL_H
#define TTVXSDEVICEGLOBAL_H

#include "base/ConfigKey.h"
#include "device-modules/ModularDeviceConfig.h"
#include "mstream-mreg-dev-global/MstreamMregDevGlobal.h"
#include "TtvxsStatus.h"

struct FeLinkStatus;
class RcRunId;
class RunControlAppConfig;
class TtvxsDevice;

class TtvxsDeviceGlobal : public MstreamMregDevGlobal
{
    Q_OBJECT
public:
    TtvxsDeviceGlobal(const DeviceIndex &index, QObject *parent = nullptr);

public slots:

private slots:
    void statusUpdated(const TtvxsStatus &status);

signals:
    void statusUpdated_(const TtvxsStatus &st, const TtvxsStatus &prev_st);
    void feLinkStatusUpdated(const DeviceIndex &index, const QMap<int,FeLinkStatus> &stMap) const;

    //=== signals from MainWindow
    void resetTimestamp(DeviceIndex=DeviceIndex());
    void clearStat(DeviceIndex=DeviceIndex());
    void evNumReset(DeviceIndex=DeviceIndex(), const QVariant &startEvNum={});
    void softClear(DeviceIndex=DeviceIndex());
    void restartAll(const RcRunId &runId, const QVariant &startEvNum = {}) const;

    void getTrigEvNum(int checkIndex, bool local=true);
    void topEvNumResponse(int check_index, quint64 evNum);
    void evNumResponse(int check_index, const DeviceIndex &index, quint64 evNum);


private:
    TtvxsStatus prev_status;
    ModularDeviceConfig ttvxs_config;
};

#endif // TTVXSDEVICEGLOBAL_H
