#include "ConfigMetaConverter.h"
#include <QHostInfo>

template<>
bool AbstractConfigConverter<ConfigMeta>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<ConfigMeta>::toJsonObject(const ConfigMeta &in)
{
    QVariantMap m;
    m[k_current_host] = QVariant::fromValue(in.getCurrentHost().hostName());
    m[k_date_of_modification] = QVariant::fromValue(
        in.getModificationTimestamp().toString(Qt::ISODate)
    );
    m[k_phantom] = QVariant::fromValue(in.isPhantom());
    return fromVariantMap(m);
}

template<>
ConfigMeta AbstractConfigConverter<ConfigMeta>::fromJsonObject(const QJsonObject &json)
{
    QHostInfo current_host = QHostInfo::fromName(QVariant::fromValue(json[k_current_host]).value<QString>());
    auto date_of_modification = QDateTime::fromString(
        QVariant::fromValue(json[k_date_of_modification]).value<QString>(),
        Qt::ISODate
    );
    auto phantom = QVariant::fromValue(json[k_phantom]).value<bool>();
    return ConfigMeta(current_host, date_of_modification, phantom);
    return ConfigMeta();
}

template<>
QJsonValue AbstractConfigConverter<ConfigMeta>::toJsonValue(const ConfigMeta &in)
{
    return toJsonObject(in);
}

template<>
ConfigMeta AbstractConfigConverter<ConfigMeta>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<ConfigMeta>::registerSubTypes()
{}
