#ifndef DEVICEINDEXENABLED_H
#define DEVICEINDEXENABLED_H

#include <QVector>
#include <QMap>
#include <QMetaType>

#include "DeviceIndex.h"

class QDebug;

struct DeviceIndexEnabled
{
    DeviceIndexEnabled(const DeviceIndex &index = DeviceIndex(), bool enabled = false)
        : index(index), enabled(enabled) { }

    bool isNull() const { return index.isNull(); }

    friend QDebug operator<<(QDebug dbg, const DeviceIndexEnabled &r);
    bool operator==(const DeviceIndexEnabled &r) const {
        return index == r.index && enabled == r.enabled;
    }
    bool operator!=(const DeviceIndexEnabled &r) const {
        return ! (*this == r);
    }

    DeviceIndex index;
    bool enabled = false;
};

struct DeviceIndexEnabledMap;
struct DeviceIndexEnabledVector;

struct DeviceIndexEnabledMap : public QMap<DeviceIndex, DeviceIndexEnabled>
{
    explicit operator DeviceIndexSet() const;
    explicit operator DeviceIndexEnabledVector() const;
    DeviceIndexSet getEnabled() const;
};

Q_DECLARE_METATYPE(DeviceIndexEnabledMap)

struct DeviceIndexEnabledVector : public QVector<DeviceIndexEnabled>
{
    explicit operator DeviceIndexSet() const;
    explicit operator DeviceIndexEnabledMap() const;
};

Q_DECLARE_METATYPE(DeviceIndexEnabledVector)

#endif // DEVICEINDEXENABLED_H
