#include "CalConfigDb.h"

#include <QTimer>
#include <QDebug>

CalConfigDb::CalConfigDb(QObject *parent) : QObject(parent)
{
    QTimer::singleShot(0, this, &CalConfigDb::update_config_from_db);
}

void CalConfigDb::setCalConfig(const ConfigKey &config_key, const CalConfig &newConfig)
{
    Q_UNUSED(config_key)
    if (newConfig == cacheCalConfig)
        return;
    cacheCalConfig = newConfig;
    cacheCalConfig.writeAll();
}

void CalConfigDb::update_config_from_db()
{
    cacheCalConfig.reloadCalibration();
    emit calConfigChanged(cacheCalConfig);
}
