/*
**    Copyright 2013-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DecoderConfig.h"

#include <cstdio>
#include <cmath>

using namespace dsplib;

//template<class T>
//bool INRANGE(const T &x, const T &min, const T &max)
//{
//    return !(x < min || x > max);
//}

//  // a bypass filter
//  fir.offs=0;
//  fir.bits=1;
//  fir.coef = {1};

//    // a useful filter
//    fir.offs = 5;
//    fir.bits = 10;
//    fir.coef = {11, 37, 183, 449, 511, 133, -349, -455, -235, -57, -20, -6};


bool DecoderChannelConfig::isValid() const
{
    return !fir.empty();
}

bool DecoderConfig::isValid() const
{
    bool ok = true;
    ok &= fitprof.isValid();
    ok &= channels.isValid();
    return ok;
}
