//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/*
#include <vector>
#include <algorithm>
#include "dsplib/Deconvolver.h"
#include "dsplib/fftengine.h"
#include "dsplib/dsplib.h"
#include "dsplib/VectorOp.h"
#include "colorlog/log.h"

using colorlog::log_pri;

Deconvolver::Deconvolver()
    : fft(new RFFTEngine)
{
}

Deconvolver::~Deconvolver()
{
    delete fft;
}


/// Deconvolution FIR(int) filter generation
///
/// \warning not tested
/// \return 0 on success

IntFir Deconvolver::create_deconvolution_FIR (const std::vector<int> &origImp, const std::vector<int> &reqImp)
{
    IntFir intfir;
    const int firBits = intfir.bits;
//    const size_t firMaxSize = FIRMAXLEN;
    const double firMaxAmplification = 0; // no limit // FIR_MAX_AMPLIF
    const double origMinPower = 1e-15; // no limit, prevent division by zero
    const double reqMinPower = 0; // no limit

    std::vector<double> dblOrigImp(origImp.size());
    for(size_t i=0; i<origImp.size(); i++)
        dblOrigImp[i] = origImp[i];
    std::vector<double> dblReqImp(reqImp.size());
    for(size_t i=0; i<reqImp.size(); i++)
        dblReqImp[i] = reqImp[i];
    const std::vector<double> &dblFirImp = make_deconvolution_dblFIR(
            dblOrigImp, dblReqImp, origMinPower, reqMinPower, firMaxAmplification);
    intfir.coef = Make_Discrete (dblFirImp, firBits);
    // FIXME: truncate FIR impulse around its center
    intfir.offs = 0; // FIXME: find FIR offset
    intfir.bits = firBits;
    return intfir;
}

///
/// Deconvolution FIR filter generation
///
/// \param impOrig Original signal
/// \param impReq Desired signal
/// \param origMinPower Power spectrum threshold for \a impOrig
/// \param reqMinPower Power spectrum threshold for \a impReq
/// \param firMaxAmplification Maximum amplification factor
/// \returns FIR coefficients
///
/// Real data deconvolution in time domain is equivalent to complex division
/// in frequency domain. Complex spectrum compoments of \a impOrig
/// are divided by corresponding component of \a impReq.
/// Spectrum components with power below the threshold are zeroed.
/// The amplification of resulting FIR is limited by spectrum component
/// by \a firMaxAmplification factor.
/// \warning origMinPower must not be zero, otherwise nan will occur (division by zero)

std::vector<double> Deconvolver::make_deconvolution_dblFIR (const std::vector<double> &impOrig,
                                               const std::vector<double> &impReq,
                                               double origMinPower, double reqMinPower,
                                               double firMaxAmplification)
{
    if (impOrig.empty() || impReq.empty()) return std::vector<double>(1,1);

    // Calculate signal DC component
    const double dcOrig = dcdbl (impOrig);
    const double dcReq = dcdbl (impReq);
    // Calculate signal RMS power
    const double origRms = rmsdbl (impOrig, dcOrig);
    const double reqRms = rmsdbl (impReq, dcReq);

    if (reqRms == 0) {
        const std::vector<double> defaultImp(1, 1);
        log_pri (LOG_CRIT, "Source signal is zero. Cannot make FIR");
        return defaultImp;
    }

    std::vector<std::complex<double> > origDFT = fft->DFT(impOrig); // real to complex
    std::vector<std::complex<double> > reqDFT = fft->DFT(impReq);
    // extend with zeroes
    const size_t extSize = std::max(origDFT.size(), reqDFT.size());
    origDFT.resize(extSize);
    reqDFT.resize(extSize);
//    std::cerr << "origDFT = " << origDFT << std::endl;
//    std::cerr << "reqDFT  = " << reqDFT << std::endl;

    // with limiter
    const double ratio = reqRms / origRms;
    const double maxspamp = ratio * firMaxAmplification;
    std::vector<std::complex<double> > firDFT(extSize);
    for(size_t i=0; i<extSize; i++) { // TODO: do not process right half of DFT, it is zero.
        if (std::abs(origDFT[i]) < origMinPower)
            continue;
        if (std::abs(reqDFT[i]) < reqMinPower)
            continue;
        if (origDFT[i] == 0.) continue;
        if (reqDFT[i] == 0.) continue;
        firDFT[i] = reqDFT[i] / origDFT[i];
        if (firMaxAmplification>0) {
            if (std::abs(firDFT[i]) > firMaxAmplification)
                firDFT[i] *= maxspamp/std::abs(firDFT[i]);
        }
    }
    //  const std::vector<std::complex<double> > &firDFT = reqDFT/srcDFT; // without limiters
//    std::cerr << "firDFT = " << firDFT << std::endl;

    std::vector<double> firImp = fft->IDFT(firDFT); // complex to real
    firImp = firImp / double(firImp.size()); // Normalization

    // TODO: run FIR check
    firImp.resize(firImp.size()/2);
    return firImp;
}
*/
