/*
**    Copyright 2009-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "FitterBase.h"

#include "lmfit.h"

namespace dsplib {

FitterBase::FitterBase(unsigned int fit_points)
{
    ws = 0;
}

FitterBase::~FitterBase()
{
    struct lm_ws_t *p = ws;
    ws = 0;
    if (p)
        lm_free_ws(p);
}

unsigned int FitterBase::getMaxFitPoints() const
{
    if (!ws) return 0;
    return ws->dim_m;
}

} // namespace dsplib
