/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef AD5622CONFIG_H
#define AD5622CONFIG_H

#include <QMetaType>

enum {
    AMP_BOARD_NONE       = 0x0,
    AMP_BOARD_PCA        = 0x1, // deprecated
    AMP_BOARD_AD5622     = 0x2,
    AMP_BOARD_AD5622v2   = 0x3
};

struct Ad5622Config
{
    friend bool operator==(const Ad5622Config &, const Ad5622Config &) = default;
    quint16 boardSet = 0; // to enum, move to ad5622operation
    quint16 baseline = 0;
    quint16 level = 0;
};
Q_DECLARE_METATYPE(Ad5622Config)

#endif // AD5622CONFIG_H
