#include "Ad5622Module.h"

#include "regio/regop.h"

#include "Ad5622Config.h"
#include "sdb/AfiSdbId.h"

enum {
    REG32_ID        = 0x0,

    REG_AMP_SET     = 0x8,
    REG_COMMAND     = 0x9,
    REG_BASELINE    = 0xA,
    REG_LEVEL       = 0xB,
};

enum {AD5622_WRITE_COMMAND = 0x180};

QList<AFI_SDB_ID> Ad5622Module::getSupportedSdbIds()
{
    return { AFI_SDB_AD5622 };
}

bool Ad5622Module::writeConfig(const Ad5622Config &cfg)
{
    RegOpVector r;
    r.RegWrite16(REG_AMP_SET, cfg.boardSet);
    switch (cfg.boardSet) {
    case AMP_BOARD_AD5622: // fall through
    case AMP_BOARD_AD5622v2:
        r.RegWrite16(REG_BASELINE, cfg.baseline);
        r.RegWrite16(REG_LEVEL, cfg.level);
        r.RegWrite16(REG_COMMAND, AD5622_WRITE_COMMAND);            break;
    }

    return regOpExecRebased(r);
}
