#ifndef ADCDATATESTMODULE_H
#define ADCDATATESTMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"

struct AdcDataTestStatus;
struct AdcPatternStatus;

class AdcDataTestModule : public BaseDeviceModule<AdcDataTestModule>
{
public:
    explicit AdcDataTestModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    void post_init() override;
    bool supportPRBS() const;

    std::optional<AdcDataTestStatus> readStatus();
    bool readStatus(AdcDataTestStatus *result);

    bool readPatternStatus(AdcPatternStatus *result);
    bool setTestPatternAndEnable(quint16 pattern);
    bool setPatternTestEn(bool en);
    bool setPRBSEn(bool en);
    quint64 getPatternTestCount();
    quint64 getPatternTestFailedChWithStop();
    bool getPatternTestFailedChWithPause(quint64 *result);

private:
    quint16 regCtrl = 0;
};

#endif // ADCDATATESTMODULE_H
