#ifndef ADCLEMOMUXMODULE_H
#define ADCLEMOMUXMODULE_H

#include <optional>

#include "AdcLemoMuxBuildParams.h"
#include "device-modules/BaseDeviceModule.h"

struct AdcLemoMuxCtrlConfig;
namespace mlink { class RegOpVector; }

class AdcLemoMuxModule : public BaseDeviceModule<AdcLemoMuxModule>
{
public:
    explicit AdcLemoMuxModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    std::optional<AdcLemoMuxBuildParams> getBuildParam() const
    {
        return buildParams;
    }

    bool writeConfig(const AdcLemoMuxCtrlConfig &cfg);

private:
    std::optional<AdcLemoMuxBuildParams> buildParams;
};

#endif // ADCLEMOMUXMODULE_H
