#ifndef ADCSPIBASEMODULE_H
#define ADCSPIBASEMODULE_H

#include <QtGlobal>
#include <QMap>

class AdcSpiBaseModule
{
public:
    void setAdcChips(quint16 chips) { adcChips=chips; }

    virtual bool setCustomPatternMode(bool mode) = 0;
    virtual bool setPRBSMode(bool) { return false; }
    virtual bool setCustomPattern(quint16 data) = 0;
    int getDataBits() const { return adcDataBits; }
    virtual bool setupAdc() = 0;
    bool spi_test();
    virtual bool supportPRBS() const { return false; }

protected:
    struct TestResult
    {
        bool isOk() const {
            for (const auto &i : map)
                if (!i)
                    return false;
            return true;
        }
        QMap<int, bool> map;
    };
    virtual bool spi_test_impl(TestResult *result) = 0;
    inline quint16 getAdcMask() const { return (1<<adcChips)-1; }

    int adcDataBits = 16;
    int adcChips = 0;
    int adcChPerChip = 0;
};

#endif // ADCSPIBASEMODULE_H
