/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CROSSPOINTSWITCHBUILDPARAMS_H
#define CROSSPOINTSWITCHBUILDPARAMS_H

#include <QtGlobal>
#include <QMetaType>
#include <QStringList>

struct CrosspointSwitchBuildParams
{
    friend bool operator==(const CrosspointSwitchBuildParams &, const CrosspointSwitchBuildParams &) = default;
    bool isValid() const;

    quint32 id = 0;
    quint16 inSize = 0;
    quint16 outSize = 0;
    quint16 outArrayAddr = 0;
};
Q_DECLARE_METATYPE(CrosspointSwitchBuildParams)

#endif // CROSSPOINTSWITCHBUILDPARAMS_H
