#include "AdcSerDesDelayConverter.h"

#include "base/ConfigConverterUtil.h"
#include "base/DeviceIndexConverter.h"

#include "AdcSerDesDelay.h"

// --------- AdcSerDesDelay

template<>
bool AbstractConfigConverter<AdcSerDesDelay>::classIsObject()
{
    return false;
}

template<>
QJsonObject AbstractConfigConverter<AdcSerDesDelay>::toJsonObject(const AdcSerDesDelay &)
{Q_UNREACHABLE();}

template<>
AdcSerDesDelay AbstractConfigConverter<AdcSerDesDelay>::fromJsonObject(const QJsonObject &)
{Q_UNREACHABLE();}

template<>
QJsonValue AbstractConfigConverter<AdcSerDesDelay>::toJsonValue(const AdcSerDesDelay &in)
{
    return QJsonArray{in.clock,in.data};
}

template<>
AdcSerDesDelay AbstractConfigConverter<AdcSerDesDelay>::fromJsonValue(const QJsonValue &in)
{
    const auto &arr = in.toArray();
    return {arr.first().toInt(),arr.last().toInt()};
}

template<>
void AbstractConfigConverter<AdcSerDesDelay>::registerSubTypes()
{
}

// -------------- AdcSerDesDelayMap
template<>
bool AbstractConfigConverter<AdcSerDesDelayMap>::classIsObject()
{
    return true;
}

template<>
QJsonValue AbstractConfigConverter<AdcSerDesDelayMap>::toJsonValue(const AdcSerDesDelayMap &in)
{
    return ConfigConverterUtil::toJsonValue(in.map);
}

template<>
QJsonObject AbstractConfigConverter<AdcSerDesDelayMap>::toJsonObject(const AdcSerDesDelayMap &in)
{
    return toJsonValue(in).toObject();
}

template<>
AdcSerDesDelayMap AbstractConfigConverter<AdcSerDesDelayMap>::fromJsonObject(const QJsonObject &in)
{
    AdcSerDesDelayMap out;
    out.map = ConfigConverterUtil::toMap<int, AdcSerDesDelay>(in);
    return out;
}

template<>
AdcSerDesDelayMap AbstractConfigConverter<AdcSerDesDelayMap>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());

}

template<>
void AbstractConfigConverter<AdcSerDesDelayMap>::registerSubTypes()
{
    AbstractConfigConverter<AdcSerDesDelay>::registerTypes();
}


// -------------- DevSerDesDelayMap
template<>
bool AbstractConfigConverter<DevSerDesDelayMap>::classIsObject()
{
    return true;
}

template<>
QJsonValue AbstractConfigConverter<DevSerDesDelayMap>::toJsonValue(const DevSerDesDelayMap &in)
{
    return ConfigConverterUtil::toJsonValue(in.map);
}

template<>
QJsonObject AbstractConfigConverter<DevSerDesDelayMap>::toJsonObject(const DevSerDesDelayMap &in)
{
    return toJsonValue(in).toObject();
}

template<>
DevSerDesDelayMap AbstractConfigConverter<DevSerDesDelayMap>::fromJsonObject(const QJsonObject &in)
{
    DevSerDesDelayMap out;
    out.map = ConfigConverterUtil::toMap<DeviceIndex, AdcSerDesDelayMap>(in);
    return out;
}

template<>
DevSerDesDelayMap AbstractConfigConverter<DevSerDesDelayMap>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());

}

template<>
void AbstractConfigConverter<DevSerDesDelayMap>::registerSubTypes()
{
    AbstractConfigConverter<AdcSerDesDelayMap>::registerTypes();
}
