#ifndef MSCCORECONFIG_H
#define MSCCORECONFIG_H

#include <QMap>
#include <QMetaType>

#include "device-modules/MscHist/MscHistConfig.h"
#include "device-modules/MscInput/MscInputConfig.h"
#include "device-modules/MscStream/MscStreamConfig.h"

struct MscCoreConfig
{
    friend bool operator==(const MscCoreConfig &, const MscCoreConfig &) = default;
    void mergeLocalData(const MscCoreConfig &r)
    {
        hist = r.hist;
        input = r.input;
        chThreshold = r.chThreshold;
        chPolarity = r.chPolarity;
    }

    MscStreamConfig mstream;
    MscHistConfig hist;
    MscInputConfig input;
    QMap<int, int> chThreshold; // per channel
    QMap<int, bool> chPolarity; // per channel, 0: positive, 1: negative
};
Q_DECLARE_METATYPE(MscCoreConfig)

#endif // MSCCORECONFIG_H
