#ifndef MSCHISTMODULE_H
#define MSCHISTMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"
#include "MscHistStatus.h"
#include "MscHistConfig.h"
//class MscHistConfig;

class MscHistModule : public BaseDeviceModule<MscHistModule>
{
public:
    explicit MscHistModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    void post_init() final;
    void setHistNum(quint16 _histNum) { histNum = _histNum; }

    std::optional<MscHistBuildParams> getBuildParam() const
    {
        return buildParams;
    }

    bool writeConfig(const MscHistConfig &hist);
    bool readStatus(MscHistStatus *result);
    std::optional<MscHistStatus> readStatus();

private:
    int getHistCount() const;
    mlink::RegOpVector setConfigRegOp(const MscHistConfig &hist);
    mlink::RegOpVector getStatusRegOp(MscHistStatus *result) const;

    std::optional<MscHistBuildParams> readBuildParam();
    std::optional<MscHistBuildParams> buildParams;
    std::optional<quint16> histNum;
};

#endif // MSCHISTMODULE_H
