#include "SpillStatus.h"

#include <QString>

#include "device-modules/RegWrTimeTai.h"

QString SpillStatusBits::toString() const
{
    return QString("%1 %2 sel=%3 phase=%4 (0x%5)")
            .arg(reg.bit.ttl_ok?"TTL_NCU_Ok":"TTL_NCU_FAIL")
            .arg(reg.bit.wr_ok?"WR_NCU_Ok":"WR_NCU_FAIL")
            .arg(reg.bit.sel)
            .arg(reg.bit.phase)
            .arg(reg.all, 8, 16, QChar('0'))
            ;
}

TaiTime SpillStatus::lastSpillTai() const
{
    reg_wr_time_tai taiReg{lastSpillTaiRaw};
    return taiReg.toTaiTime();
}
