#include "Tlu40LvdsLuminosityConfigConverter.h"

#include "Tlu40LvdsLuminosityConfig.h"

namespace {
// Tlu40LvdsLuminosityConfig
constexpr const char *k_shaperVal = "shaperVal";
constexpr const char *k_chEn = "chEn";
}

// -------------- Tlu40LvdsLuminosityConfig
template<>
bool AbstractConfigConverter<Tlu40LvdsLuminosityConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<Tlu40LvdsLuminosityConfig>::toJsonObject(const Tlu40LvdsLuminosityConfig &in)
{
    QVariantMap m;
    m[k_chEn] = ConfigConverterUtil::toJsonValue(in.chEn);
    m[k_shaperVal] = QVariant::fromValue(in.shaperVal);
    return fromVariantMap(m);
}

template<>
Tlu40LvdsLuminosityConfig AbstractConfigConverter<Tlu40LvdsLuminosityConfig>::fromJsonObject(const QJsonObject &in)
{
    Tlu40LvdsLuminosityConfig out;
    out.chEn = ConfigConverterUtil::toVector<bool>(in[k_chEn]);
    update_value(in, k_shaperVal, &out.shaperVal);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<Tlu40LvdsLuminosityConfig>::toJsonValue(const Tlu40LvdsLuminosityConfig &in)
{
    return toJsonObject(in);
}

template<>
Tlu40LvdsLuminosityConfig AbstractConfigConverter<Tlu40LvdsLuminosityConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<Tlu40LvdsLuminosityConfig>::registerSubTypes()
{
}
