#include "TrcCoreConfigConverter.h"

#include "device-modules/TrcCore/PhysicalTrigger/PhysicalTriggerConfig.h"

namespace {
constexpr const char *k_phyTrig = "phyTrig";
} // namespace

template<>
bool AbstractConfigConverter<TrcCoreConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<TrcCoreConfig>::toJsonObject(const TrcCoreConfig &in)
{
    QVariantMap m;
    m[k_phyTrig] = QVariant::fromValue(in.phyTrig);

    return fromVariantMap(m);
}

template<>
TrcCoreConfig AbstractConfigConverter<TrcCoreConfig>::fromJsonObject(const QJsonObject &in)
{
    TrcCoreConfig out;
    update_value(in, k_phyTrig, &out.phyTrig);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<TrcCoreConfig>::toJsonValue(const TrcCoreConfig &in)
{
    return toJsonObject(in);
}

template<>
TrcCoreConfig AbstractConfigConverter<TrcCoreConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<TrcCoreConfig>::registerSubTypes()
{
    AbstractConfigConverter<DeviceIndex>::registerTypes();
    AbstractConfigConverter<PhysicalTriggerConfig>::registerTypes();
}
