#ifndef TRIGCTRLSTATMODULE_H
#define TRIGCTRLSTATMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include "TrigCtrlStatStatus.h"
#include <optional>

class TrigCtrlStatConfig;

class TrigCtrlStatModule : public BaseDeviceModule<TrigCtrlStatModule>
{
public:
    explicit TrigCtrlStatModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;
    std::optional<TrigCtrlBuildParams> getBuildParam() const { return buildParam; }

    bool writeConfig(const TrigCtrlStatConfig &newConfig);
    bool softreset();
    bool readStatus(TrigCtrlStatStatus *result);
    std::optional<TrigCtrlStatStatus> readStatus();
    // QMap<int, QString> getSourceLabels() const;

private:
    std::optional<TrigCtrlStatStatus> statusCache;
    std::optional<TrigCtrlBuildParams> buildParam;
};

#endif // TRIGCTRLSTATMODULE_H
