/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef WAVERECSTATUS_H
#define WAVERECSTATUS_H

#include <QMetaType>

class WaveRecStatus
{
public:
    friend bool operator==(const WaveRecStatus &, const WaveRecStatus &) = default;
    QString getSummary() const;
    QString getFullText() const;
    bool hasErrors() const;

    quint64 hfifo = 0;
    quint64 mfifo = 0;
    quint64 efifo = 0;
};
Q_DECLARE_METATYPE(WaveRecStatus)

#endif // WAVERECSTATUS_H
