#ifndef ADCMPDTRIGMODELITEM_H
#define ADCMPDTRIGMODELITEM_H

#include "base/DeviceIndex.h"

struct AdcMpdTrigModelItem
{
    explicit AdcMpdTrigModelItem() = default;
    ~AdcMpdTrigModelItem() {
        qDeleteAll(children);
    }
    AdcMpdTrigModelItem *child(int row) const { return children.value(row, nullptr); }
    AdcMpdTrigModelItem *createChild() {
        auto child = new AdcMpdTrigModelItem();
        child->dev = dev;
        child->group = group;
        child->parent = this;
        children.push_back(child);
        return child;
    }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<AdcMpdTrigModelItem*>(this));
        return 0;
    }

    DeviceIndex dev;
    int group=-1;
    int ch=-1;
    AdcMpdTrigModelItem *parent = nullptr;
    QVector<AdcMpdTrigModelItem *> children;
};
#endif // ADCMPDTRIGMODELITEM_H
