#ifndef DEVICECHTREEVIEW_H
#define DEVICECHTREEVIEW_H

#include <QTreeView>
#include "base/DeviceIndex.h"

class QSettings;

class DeviceChModel;
struct DeviceIndexEnabledMap;
class SpinBoxDelegate;
struct ModularDeviceStatus;

class DeviceChTreeView : public QTreeView
{
public:
    explicit DeviceChTreeView(QWidget *parent = nullptr);
    void setTreeModel(DeviceChModel *treeModel);
    void saveAppGuiSettings(QSettings &) const;
    void loadAppGuiSettings(const QSettings &);
    void setseparateChEn(bool showSepCols);

private slots:
    void expanded(const QModelIndex &index);
    void collapsed(const QModelIndex &index);
    void onModelReset();

public slots:
    void expandTopItem();
    void deviceStatusUpdated(const ModularDeviceStatus &status);
    void setDeviceList(const DeviceIndexEnabledMap &map);

protected:
    void resizeEvent(QResizeEvent *event) override;

private:
    DeviceIndex getDeviceIndex(const QModelIndex &index) const;
    void addDelegate(const QModelIndex &parent = {});
    void updateColVis();

    QMap<DeviceIndex, bool> expand_device_map;
    QMap<DeviceIndex, ModularDeviceStatus> devStMap;
    DeviceIndexSet devSet;
    SpinBoxDelegate * const anlgDelegate;
    SpinBoxDelegate * const digDelegate;

    bool separateChEn = false;
};

#endif // DEVICECHTREEVIEW_H
