/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DeviceStateController.h"
#include "mregdev/qtmregdevice.h"

void DeviceStateController::deviceConnected(const DeviceIndex &index)
{
    connected = true;
    emit deviceStateChanged(index, connected);
}

void DeviceStateController::deviceDisconnected(const DeviceIndex &index)
{
    connected = false;
    emit deviceStateChanged(index, connected);
}

DeviceStateController::DeviceStateController(QtMregDevice *device, QObject *parent)
    : QObject(parent)
    , device(device)
{
    connect(device, &QtMregDevice::deviceConnected,
            this, &DeviceStateController::deviceConnected);
    connect(device, &QtMregDevice::deviceDisconnected,
            this, &DeviceStateController::deviceDisconnected);
}
