#include "RcProgramStateTreeItem.h"

RcProgramStateTreeItem::~RcProgramStateTreeItem()
{
    qDeleteAll(children);
}

RcClientPath RcProgramStateTreeItem::getPath() const
{
    RcClientPath p;
    if(parent)
        p = parent->getPath();
    p << index;
    return p;
}

RcProgramStateTreeItem *RcProgramStateTreeItem::child(int row) const
{
    int r = 0;
    for (auto it = children.begin(); it != children.end(); ++it)
        if (r++ == row)
            return *it;
    return {};
}

int RcProgramStateTreeItem::childCount() const
{
    return children.count();
}

int RcProgramStateTreeItem::row() const
{
    if (parent)
        return parent->children.indexOf(const_cast<RcProgramStateTreeItem*>(this));

    return 0;

}
