#ifndef MONGOHOST_H
#define MONGOHOST_H

#include <QList>
#include <QMetaType>
#include <QString>
#include <QUrl>

#include "MongoDatabase.h"

class MongoHost
{
public:
    MongoHost();
    void clear(){
        url.clear();
        db.clear();
    }
    bool isEmpty() const{
        return url.isEmpty();
    }
    bool operator==(const MongoHost &cred) const;
    QUrl get_url() const { return url; }
    QString get_uri_string() const { return url.toString(); }
    QString environment;
    QUrl url;
    bool enable = true;
    QString db;
    QList<MongoDatabase> databeses;
    bool is_set = false;
    bool is_connect = false;
};
Q_DECLARE_METATYPE(MongoHost);

#endif // MONGOHOST_H
