#include "MongoPipeline.h"
#include "BsonQtConverter.h"

using bsoncxx::builder::basic::kvp;
using bsoncxx::builder::basic::make_document;

MongoPipeline::MongoPipeline()
{}

const mongocxx::pipeline &MongoPipeline::get_pipeline()
{
    return p;
}

void MongoPipeline::group(const QJsonObject &obj)
{
    p.group(BsonQtConverter::from_json(obj));
}

void MongoPipeline::match(const QJsonObject &obj)
{
    p.match(BsonQtConverter::from_json(obj));
}

void MongoPipeline::project(const QJsonObject &obj)
{
    p.project(BsonQtConverter::from_json(obj));
}

void MongoPipeline::sort(QString field, bool ascending)
{
    if(ascending)
        p.sort(make_document(kvp(field.toStdString(), 1)));
    else
        p.sort(make_document(kvp(field.toStdString(), -1)));
}


