#ifndef PNPDISCOVERYFILTER_H
#define PNPDISCOVERYFILTER_H

#include <QObject>
#include <QSet>

#include "base/DaqModule.h"

class PnpInfoCache;

class PnpDiscoveryFilter : public QObject
{
    Q_OBJECT
public:
    PnpDiscoveryFilter(const QSet<DaqModule> &filter, QObject *parent = nullptr)
        : QObject(parent), filter(filter) {}
    explicit PnpDiscoveryFilter(QObject *parent = nullptr);

public slots:
    void pnpCacheUpdated(const PnpInfoCache &cache);

signals:
    void pnpCacheUpdatedFiltered(const PnpInfoCache &cache);

private:
    const QSet<DaqModule> filter;
};

#endif // PNPDISCOVERYFILTER_H
